#include "libbcd20.h"

unsigned char b20bcd0;		// <b20bcd5> <b20bcd4> <b20bcd3> <b20bcd2> <b20bcd1> <b20bcd0>
unsigned char b20bcd1;		// dddd dddd dddd dddd dddd dddd dddd bbbb bbbb bbbb bbbb bbbb
unsigned char b20bcd2;		// <---------- 7 keta BCD ----------> <----- 20 bit BIN ----->
unsigned char b20bcd3;		//                            ^             |
unsigned char b20bcd4;		//                            +-- convert --+
unsigned char b20bcd5;
 
/*------------------------------------------------------------------------------
 *
 *	BIN -> BCD 変換
 *
 *	b20bcd2 = 0;
 *	b20bcd1 = ADRESH;
 *	b20bcd0 = ADRESL;
 *	bin20_to_bcd();
 */
void bin20_to_bcd() {
	unsigned char i;
	__asm
		BANKSEL	_b20bcd2		;							BANKSEL	_b20bcd2
		movlw	0x0F			;							LD		A, 0x0F
		andwf	_b20bcd2, F		;							AND		(_b20bcd2), A
						;	
		BANKSEL	_b20bcd3		;							BANKSEL	_b20bcd3
		clrf	_b20bcd3		;							CLR		(_b20bcd3)
						;	
		BANKSEL	_b20bcd4		;							BANKSEL	_b20bcd4
		clrf	_b20bcd4		;							CLR		(_b20bcd4)
						;	
		BANKSEL	_b20bcd5		;							BANKSEL	_b20bcd5
		clrf	_b20bcd5		;							CLR		(_b20bcd5)
	__endasm;
	for(i = 0; i < 20; i++) {
	__asm
		BANKSEL	_b20bcd2		;							BANKSEL	_b20bcd2
		movlw	0x30			;							LD		A, 0x30					; +0x30: 00110000
		addwf	_b20bcd2, F		;							ADD		(_b20bcd2), A			; keta += 3
		movlw	0xD0			;							LD		A, 0xD0					; -0x30: 11010000
		btfss	_b20bcd2, 7		;							SKIPSET	7, (_b20bcd2)
		addwf	_b20bcd2, F		;							ADD		(_b20bcd2), A			; keta -= 3
						;	
		BANKSEL	_b20bcd3		;							BANKSEL	_b20bcd3
		movlw	0x33			;							LD		A, 0x33
		addwf	_b20bcd3, F		;							ADD		(_b20bcd3), A
		movlw	0xFD			;							LD		A, 0xFD
		btfss	_b20bcd3, 3		;							SKIPSET	3, (_b20bcd3)
		addwf	_b20bcd3, F		;							ADD		(_b20bcd3), A
		movlw	0xD0			;							LD		A, 0xD0
		btfss	_b20bcd3, 7		;							SKIPSET	7, (_b20bcd3)
		addwf	_b20bcd3, F		;							ADD		(_b20bcd3), A
						;	
		BANKSEL	_b20bcd4		;							BANKSEL	_b20bcd4
		movlw	0x33			;							LD		A, 0x33
		addwf	_b20bcd4, F		;							ADD		(_b20bcd4), A
		movlw	0xFD			;							LD		A, 0xFD
		btfss	_b20bcd4, 3		;							SKIPSET	3, (_b20bcd4)
		addwf	_b20bcd4, F		;							ADD		(_b20bcd4), A
		movlw	0xD0			;							LD		A, 0xD0
		btfss	_b20bcd4, 7		;							SKIPSET	7, (_b20bcd4)
		addwf	_b20bcd4, F		;							ADD		(_b20bcd4), A
						;	
		BANKSEL	_b20bcd5		;							BANKSEL	_b20bcd5
		movlw	0x33			;							LD		A, 0x33
		addwf	_b20bcd5, F		;							ADD		(_b20bcd5), A
		movlw	0xFD			;							LD		A, 0xFD
		btfss	_b20bcd5, 3		;							SKIPSET	3, (_b20bcd5)
		addwf	_b20bcd5, F		;							ADD		(_b20bcd5), A
		movlw	0xD0			;							LD		A, 0xD0
		btfss	_b20bcd5, 7		;							SKIPSET	7, (_b20bcd5)
		addwf	_b20bcd5, F		;							ADD		(_b20bcd5), A
#ifdef SDCC_pic16
		BANKSEL	_b20bcd0		;							BANKSEL	_b20bcd0
		rlcf	_b20bcd0, F		;							RLC		(_b20bcd0)				; C <= bbbbbbbC
		BANKSEL	_b20bcd1		;							BANKSEL	_b20bcd1
		rlcf	_b20bcd1, F		;							RLC		(_b20bcd1)
		BANKSEL	_b20bcd2		;							BANKSEL	_b20bcd2
		rlcf	_b20bcd2, F		;							RLC		(_b20bcd2)
		BANKSEL	_b20bcd3		;							BANKSEL	_b20bcd3
		rlcf	_b20bcd3, F		;							RLC		(_b20bcd3)
		BANKSEL	_b20bcd4		;							BANKSEL	_b20bcd4
		rlcf	_b20bcd4, F		;							RLC		(_b20bcd4)
		BANKSEL	_b20bcd5		;							BANKSEL	_b20bcd5
		rlcf	_b20bcd5, F		;							RLC		(_b20bcd5)
#else
		BANKSEL	_b20bcd0		;							BANKSEL	_b20bcd0
		rlf	_b20bcd0, F		;							RL		(_b20bcd0)				; C <= bbbbbbbC
		BANKSEL	_b20bcd1		;							BANKSEL	_b20bcd1
		rlf	_b20bcd1, F		;							RL		(_b20bcd1)
		BANKSEL	_b20bcd2		;							BANKSEL	_b20bcd2
		rlf	_b20bcd2, F		;							RL		(_b20bcd2)
		BANKSEL	_b20bcd3		;							BANKSEL	_b20bcd3
		rlf	_b20bcd3, F		;							RL		(_b20bcd3)
		BANKSEL	_b20bcd4		;							BANKSEL	_b20bcd4
		rlf	_b20bcd4, F		;							RL		(_b20bcd4)
		BANKSEL	_b20bcd5		;							BANKSEL	_b20bcd5
		rlf	_b20bcd5, F		;							RL		(_b20bcd5)
#endif
	__endasm;
	}
}

