#include "libeeprom.h"

/*------------------------------------------------------------------------------
 *
 *	EEPROM 読み込み
 *
 *	EEADR = 0;									// set address
 *	readEeprom();
 *	x = EEDATA;									// get data
 */
void readEeprom() {

	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.RD = 1;
}

/*------------------------------------------------------------------------------
 *
 *	EEPROM 書き込み
 *
 *	EEADR = 0;									// set address
 *	EEDATA = 10;								// set data
 *	writeEeprom();
 */
void writeEeprom() {

	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.WREN = 1;

	INTCONbits.GIE = 0;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;
	while(EECON1bits.WR);						// wait

	INTCONbits.GIE = 1;

	EECON1bits.WREN = 0;
}

